#include <windows.h>
#include <commctrl.h>
#include <crtdbg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include "sapLib/sapLib.h"

static const char* szControlWindowClassName = "szControlWindowClassName";
long CALLBACK ControlWndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam );
static BOOL ControlWindowClassRegistered = FALSE;
static BOOL hWndNumOfSong_enabled = FALSE;
static bool cm[4] = { false, false, false, false };
static PCMWave selected_wave = PCMWAVE_Atari;
static int hWndNumOfSong_max = 0;
static int hWndNumOfSong_current = 0;
extern int TimeLimitTime;

static HWND ControlWindow = NULL;
static HWND ChannelsHwnd[4] = { NULL, NULL, NULL, NULL };
static HWND PCMHwnd[5] = { NULL, NULL, NULL, NULL, NULL };
static HWND hWndNumOfSong;
static HWND TimeLimitEnableHwnd;
static HWND TimeLimitEditHwnd;

//-------------------------------------------------------------------------------------------------

void __cdecl OpenControlWindow( HWND parent )
{
	HINSTANCE instance = (HINSTANCE)GetWindowLong( parent, GWL_HINSTANCE );
	if( ControlWindowClassRegistered == FALSE )
	{
		WNDCLASSEX wndclass;
		wndclass.cbSize         = sizeof( wndclass );
		wndclass.style          = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
		wndclass.lpfnWndProc    = &ControlWndProc;
		wndclass.cbClsExtra     = 0;
		wndclass.cbWndExtra     = 0;
		wndclass.hInstance      = instance;
		wndclass.hIcon          = NULL;
		wndclass.hCursor        = LoadCursor( NULL, IDC_ARROW );
		wndclass.hbrBackground  = (HBRUSH)CreateSolidBrush( GetSysColor( COLOR_3DFACE ) );
		wndclass.lpszMenuName   = NULL;
		wndclass.lpszClassName  = szControlWindowClassName;
		wndclass.hIconSm        = NULL;
		ControlWindowClassRegistered = RegisterClassEx( &wndclass );
	}

	if( ControlWindow == NULL )
	{
		ControlWindow = CreateWindowEx( 0, szControlWindowClassName, "SAP Control", WS_CAPTION|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_POPUPWINDOW, 300, 300, 300, 205, parent, NULL, instance, NULL );
		RedrawWindow( ControlWindow, NULL, NULL, RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN );
	}
}

//-------------------------------------------------------------------------------------------------

void __cdecl EnableNumOfSongScroll( BOOL enable, int max, int current )
{
	hWndNumOfSong_enabled = enable;
	hWndNumOfSong_max = max;
	hWndNumOfSong_current = current;
	if( hWndNumOfSong != NULL )
	{
		EnableWindow( hWndNumOfSong, enable );
		if( enable == TRUE )
		{
			SendMessage( hWndNumOfSong, SBM_SETRANGE, 0, max - 1 );
			SendMessage( hWndNumOfSong, SBM_SETPOS, (WPARAM)current, (LPARAM)TRUE );
		}
	}
}

//-------------------------------------------------------------------------------------------------

long CALLBACK ControlWndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam )
{
	switch( iMsg )
	{
		case WM_CREATE:
		{
			HINSTANCE instance = (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE );
			LOGFONT fontLF1={ -14, 0x0, 0x0, 0x0, FW_NORMAL, 0x0, 0x0, 0x0, 0x0, 0x3, 0x2, 0x1, 0x22, "MS Sans Serif" };
			HFONT fonts1 = CreateFontIndirect( &fontLF1 );
			for( int i = 0; i < 4; i++ )
			{
				char name[64]; sprintf( name, "Channel %d", i + 1 );
				ChannelsHwnd[i] = CreateWindow( "BUTTON", name, WS_VISIBLE|WS_CHILD|BS_AUTOCHECKBOX, 30, 10 + i * 20, 80, 15, hWnd, NULL, instance, NULL );
				SendMessage( ChannelsHwnd[i], WM_SETFONT, (WPARAM)fonts1, 0 );
				SendMessage( ChannelsHwnd[i], BM_SETCHECK, (WPARAM)(cm[i] ? 0:BST_CHECKED), 0 );
			}

			for( int i = 0; i < 5; i++ )
			{
				static char* names[5] = { "Atari Wave", "FM1", "FM2", "FM3", "Saw" };
				PCMHwnd[i] = CreateWindow( "BUTTON", names[i], WS_VISIBLE|WS_CHILD|BS_AUTORADIOBUTTON, 140, 10 + i * 20, 100, 15, hWnd, NULL, instance, NULL );
				SendMessage( PCMHwnd[i], WM_SETFONT, (WPARAM)fonts1, 0 );
				int sel = (int)selected_wave;
				if( sel == i )
					SendMessage( PCMHwnd[i], BM_SETCHECK, (WPARAM)BST_CHECKED, 0 );
			}

			char str[10]; sprintf( str, "%d", TimeLimitTime );
			TimeLimitEditHwnd = CreateWindow( "EDIT", str, WS_VISIBLE|WS_CHILD|WS_BORDER, 180, 120, 40, 20, hWnd, NULL, instance, NULL );
			SendMessage( TimeLimitEditHwnd, WM_SETFONT, (WPARAM)fonts1, 0 );
			HWND wnd = CreateWindow( "STATIC", "minutes", WS_VISIBLE|WS_CHILD, 225, 122, 50, 15, hWnd, NULL, instance, NULL );
			SendMessage( wnd, WM_SETFONT, (WPARAM)fonts1, 0 );
			wnd = CreateWindow( "STATIC", "Time Limit (Winamp only)", WS_VISIBLE|WS_CHILD, 10, 120, 160, 20, hWnd, NULL, instance, NULL );
			SendMessage( wnd, WM_SETFONT, (WPARAM)fonts1, 0 );

			RECT cr; GetClientRect( hWnd, &cr );
			int x,y,sx,sy;
			x = cr.left+5; y = cr.bottom-27; sx = cr.right-cr.left-10; sy = 20;
			hWndNumOfSong = CreateWindowEx( 0, "SCROLLBAR", NULL, WS_VISIBLE|WS_CHILD|SBS_HORZ|WS_DISABLED, x, y, sx, sy, hWnd, NULL, instance, NULL );
			EnableWindow( hWndNumOfSong, hWndNumOfSong_enabled );
			if( hWndNumOfSong_enabled == TRUE )
			{
				SendMessage( hWndNumOfSong, SBM_SETRANGE, 0, hWndNumOfSong_max - 1 );
				SendMessage( hWndNumOfSong, SBM_SETPOS, (WPARAM)hWndNumOfSong_current, (LPARAM)TRUE );
			}
			return 0;
		}
		case WM_COMMAND:
		{
			for( int i = 0; i < 4; i++ )
			{
				if( (HWND)lParam == ChannelsHwnd[i] && HIWORD(wParam) == BN_CLICKED )
				{
					LRESULT state = SendMessage( ChannelsHwnd[i], BM_GETSTATE, 0, 0 );
					cm[i] = ( state & BST_CHECKED ) ? false:true;
					sapSetChannelMute( cm[0], cm[1], cm[2], cm[3] );
					break;
				}
			}
			for( int i = 0; i < 5; i++ )
			{
				if( (HWND)lParam == PCMHwnd[i] && HIWORD(wParam) == BN_CLICKED )
				{
					selected_wave = (PCMWave)i;
					sapSetPCMWave( selected_wave );
					break;
				}
			}
			if( (HWND)lParam == TimeLimitEditHwnd && HIWORD(wParam) == EN_CHANGE )
			{
				char text[100];
				SendMessage( TimeLimitEditHwnd, WM_GETTEXT, sizeof(text), (LPARAM)text );
				//TimeLimitTime = atoi( text );
				break;
			}
			break;
		}
		case WM_HSCROLL:
		{
			int low,high,pos,oldpos;
			SendMessage( (HWND)lParam, SBM_GETRANGE, (WPARAM)&low, (LPARAM)&high );
			oldpos = pos = SendMessage( (HWND)lParam, SBM_GETPOS, 0, 0 );
			if( LOWORD(wParam)==SB_LINELEFT ) pos--;
			if( LOWORD(wParam)==SB_LINERIGHT ) pos++;
			if( LOWORD(wParam)==SB_THUMBTRACK ) pos = HIWORD(wParam);
			if( pos<low ) return 0;
			if( pos>high ) return 0;
			if( oldpos==pos ) return 0;
			SendMessage( (HWND)lParam, SBM_SETPOS, (WPARAM)pos, (LPARAM)TRUE );
			extern void ChangeSongNum( int pos );
			ChangeSongNum( pos );
			return 0;
		}
		case WM_SHOWWINDOW:
			if( wParam == TRUE )
				break;
		case WM_DESTROY:
		case WM_CLOSE:
			ControlWindow = NULL;
			memset( ChannelsHwnd, 0, sizeof(ChannelsHwnd) );
			memset( PCMHwnd, 0, sizeof(PCMHwnd) );
			hWndNumOfSong = NULL;
			TimeLimitEnableHwnd = NULL;
			TimeLimitEditHwnd = NULL;
			break;
		case WM_ERASEBKGND:
			break;
		//case WM_PAINT:
		//{
		//	PAINTSTRUCT ps; HDC hdc; HBRUSH oldBrush;
		//	hdc = BeginPaint( hWnd, &ps );
		//	SetBkMode( hdc, TRANSPARENT );
		//	RECT r,cr; GetClientRect( hWnd, &cr );
		//	r = cr; r.bottom -= 32;
		//	cr.top = r.bottom;
		//	RECT r2; r2 = r;
		//	r.top += 20;
		//	r2.bottom = r2.top+20;
		//	PatBlt( hdc, r.left+1, r.top+1, r.right-r.left-2, r.bottom-r.top-2, WHITENESS );
		//	HFONT oldFont = (HFONT)SelectObject( hdc, fonts1 );
		//	{
		//		PatBlt( hdc, r2.left, r2.top, r2.right-r2.left, r2.bottom-r2.top, BLACKNESS );
		//		InflateRect( &r2, -2, -2 );
		//		COLORREF oldColor = SetTextColor( hdc, RGB(0,224,0) );
		//		DrawText( hdc, cmd1Line, -1, &r2, 0 );
		//		SetTextColor( hdc, oldColor );
		//	}
		//	DrawEdge( hdc, &r, BDR_SUNKENOUTER, BF_RECT );
		//	SetTextColor( hdc, 0 );
		//	InflateRect( &r, -5, -5 );
		//	DrawText( hdc, commentBuffer, -1, &r, 0 );
		//	oldBrush = (HBRUSH)SelectObject( hdc, GetSysColorBrush( COLOR_3DFACE ) );
		//	PatBlt( hdc, cr.left, cr.top, cr.right-cr.left, cr.bottom-cr.top, PATCOPY );
		//	SelectObject( hdc, oldBrush );
		//	SelectObject( hdc, oldFont );
		//	EndPaint( hWnd, &ps );
		//	return 0;
		//}
	}
	return DefWindowProc( hWnd, iMsg, wParam, lParam );
}

//-------------------------------------------------------------------------------------------------
