#include <windows.h>
#include <commctrl.h>
#include <dsound.h>
#include <crtdbg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#include "resource.h"

const int PRIMARYBUFFERLENGTH = 30000*4;
#define SECONDARY_SOUND_BUFFER_IN_MS	50
extern void __cdecl OpenControlWindow( HWND parent );
extern void __cdecl EnableNumOfSongScroll( BOOL enable, int max = 0, int current = 0 );
bool TimeLimitEnabled = false;
int TimeLimitTime = 3;
char cmd1Line[200];

//--------------

#include "sapLib/sapLib.h"

//--------------


char commentBuffer[65536];

sapMUSICstrc *currentMusic;
volatile int initSongNum;
HWND	hWndMain;

HINSTANCE hMainInstance;

DWORD WINAPI SoundThread( void );
short int buf[44100*2*4*2];


DWORD WINAPI DirectSoundThread( void );

char playFileName[260];

DWORD SoundThreadID;

BOOL closeingProgram;


HRESULT hr;
volatile int	lastPos;
volatile BOOL	threadIsRunning;
volatile int	sndTh;
volatile int	isSomethingToPlay;
volatile BOOL	bufferIsPlaying;
volatile BYTE	loadNewSAP;
volatile BOOL	initNewSong;

DWORD	curPlayPos,curWritePos,dwBytes1,dwBytes2;
LPVOID lpvPtr1,lpvPtr2;
DSBUFFERDESC dsdescSecondaryBuffer;
DSBUFFERDESC dsdescPrimaryBuffer;
PCMWAVEFORMAT pcmwf;
LPDIRECTSOUND lpDS_device;
LPDIRECTSOUNDBUFFER DS_PrimaryBuffer;
LPDIRECTSOUNDBUFFER DS_SecondaryBuffer;

char szPlayerWindowClassName[]="szPlayerWindowClassName";
long CALLBACK PlayerWndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam );

int MakeCorrectFna( void )
{
	if( playFileName[0]=='"' )
	{
		char *src;
		src = strchr( &playFileName[1], '"' );
		if( src==NULL )
			return 0;
		*src = 0;
		memcpy( &playFileName[0], &playFileName[1], strlen( &playFileName[1] )+1 );
	}
	FILE *tf = fopen( &playFileName[0], "r" );
	if( tf==NULL )
		return 0;
	fclose( tf );
	return 1;
}

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE prevInstance, PSTR szCmdLine, int iCmdShow )
{
MSG msg;
WNDCLASSEX wndclass;


	HWND hWnd; hWnd = FindWindow( szPlayerWindowClassName, NULL );
	if( hWnd!=NULL )
	{
		_ASSERTE(false);
		if( szCmdLine!=NULL )
		{
			COPYDATASTRUCT cds;
			cds.dwData = 0;
			cds.cbData = strlen(szCmdLine)+1;
			cds.lpData = szCmdLine;
			SendMessage( hWnd, WM_COPYDATA, 0, (LPARAM)&cds );
		}
		return 0;
	}

	hMainInstance = hInstance;

	InitCommonControls( );

	HMENU hMenu = CreateMenu();
	AppendMenu(hMenu,MF_STRING,IDM_LOAD,"Load file");
	AppendMenu(hMenu,MF_STRING,IDM_CONTROL,"SAP Control");

	wndclass.cbSize         = sizeof( wndclass );
	wndclass.style          = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wndclass.lpfnWndProc    = &PlayerWndProc;
	wndclass.cbClsExtra     = 0;
	wndclass.cbWndExtra     = 0;
	wndclass.hInstance      = hInstance;
	wndclass.hIcon          = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_ICON1) );
	wndclass.hCursor        = LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground  = (HBRUSH) GetStockObject( WHITE_BRUSH );
	wndclass.lpszMenuName   = NULL;
	wndclass.lpszClassName  = szPlayerWindowClassName;
	wndclass.hIconSm        = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_ICON1) );
	RegisterClassEx( &wndclass );

	hWndMain = CreateWindowEx( WS_EX_ACCEPTFILES, szPlayerWindowClassName, "Player v2.0", WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_OVERLAPPEDWINDOW, 100, 100, 400, 300, NULL, NULL, hMainInstance, NULL );
	SetMenu(hWndMain,hMenu);

	closeingProgram = FALSE;

	sprintf( &commentBuffer[ strlen(commentBuffer) ], "Atari Sound Emulator - SAP by\nAdam Bienias / City Interactive\n-----\nDirectSound version\n-----\nDrag .SAP file from directory browser\nand drop to this window\nor assign 'Sap.exe' to '.sap' extension.\n" );

	initNewSong = FALSE;
	loadNewSAP = 0;
	currentMusic = NULL;

	threadIsRunning = FALSE;
	CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)&DirectSoundThread, 0, 0, &SoundThreadID );

HANDLE process;
	process = GetCurrentProcess();
	SetPriorityClass( process, HIGH_PRIORITY_CLASS );

	sapSetPCMWave( PCMWAVE_Atari );
	sapSetChannelMute( false, false, false, false );

	if( szCmdLine!=NULL )
	{
		if( strlen( szCmdLine )>0 )
		{
			strcpy( &playFileName[0], szCmdLine );
			if( MakeCorrectFna( ) )
				loadNewSAP = 1;
		}
	}

	OpenControlWindow( hWndMain );

	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	if( DS_SecondaryBuffer!=NULL )
		DS_SecondaryBuffer->Stop();
	sndTh = 1;
	SetPriorityClass( process, NORMAL_PRIORITY_CLASS );
	while( threadIsRunning ){}

	if( DS_SecondaryBuffer!=NULL )
	{
		DS_SecondaryBuffer->Release( );
	}
	if( DS_PrimaryBuffer!=NULL )
	{
		DS_PrimaryBuffer->Stop( );
		DS_PrimaryBuffer->Release( );
	}
	if( lpDS_device!=NULL )
		lpDS_device->Release( );
	sndTh = 2;

	DestroyMenu(hMenu);

	return msg.wParam;

}

HFONT fonts1;

long CALLBACK PlayerWndProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam )
{
	switch( iMsg ) {
		case WM_CREATE:
		{
			LOGFONT fontLF1={ -14, 0x0, 0x0, 0x0, FW_NORMAL, 0x0, 0x0, 0x0, 0x0, 0x3, 0x2, 0x1, 0x22, "MS Sans Serif" };
			fonts1 = CreateFontIndirect( &fontLF1 );
			break;
		}
		//case WM_SIZE:
		//{
		//	RECT cr; cr.left = 0; cr.top = 0; cr.right = LOWORD(lParam); cr.bottom = HIWORD(lParam);
		//	int x,y,sx,sy;
		//	x = cr.left+10; y = cr.bottom-24; sx = cr.right-cr.left-20; sy = 20;
		//	SetWindowPos( hWndNumOfSong, NULL, x, y, sx, sy, SWP_NOZORDER );
		//	return 0;
		//}
		case WM_COMMAND:
		{
			if( HIWORD(wParam)==0 && LOWORD(wParam)==IDM_LOAD )
			{
				char filename[MAX_PATH]; filename[0] = 0;
				OPENFILENAME ofn={sizeof(OPENFILENAME),hWndMain,hMainInstance,
				"SAP Files (*.sap)\0*.sap\0\0",NULL,0,1,filename,sizeof(filename),NULL,0,
				NULL,"Open SAP File...",OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,0,0,NULL,
				0,NULL,NULL};
				if( GetOpenFileName(&ofn) )
				{
					strcpy(playFileName,filename);
					loadNewSAP = 1;
				}
			}
			if( HIWORD(wParam)==0 && LOWORD(wParam)==IDM_CONTROL )
			{
				OpenControlWindow( hWnd );
			}
			return 0;
		}
		case WM_CLOSE:
			closeingProgram = TRUE;
			sndTh = 1;
			DeleteObject( fonts1 );
			break;
		case WM_ERASEBKGND:
			return 1;
		case WM_PAINT:
		{
			PAINTSTRUCT ps; HDC hdc; HBRUSH oldBrush;
			hdc = BeginPaint( hWnd, &ps );
			SetBkMode( hdc, TRANSPARENT );
			RECT r,cr; GetClientRect( hWnd, &cr );
			r = cr;
			cr.top = r.bottom;
			RECT r2; r2 = r;
			r.top += 20;
			r2.bottom = r2.top+20;
			PatBlt( hdc, r.left+1, r.top+1, r.right-r.left-2, r.bottom-r.top-2, WHITENESS );
			HFONT oldFont = (HFONT)SelectObject( hdc, fonts1 );
			{
				PatBlt( hdc, r2.left, r2.top, r2.right-r2.left, r2.bottom-r2.top, BLACKNESS );
				InflateRect( &r2, -2, -2 );
				COLORREF oldColor = SetTextColor( hdc, RGB(0,224,0) );
				DrawText( hdc, cmd1Line, -1, &r2, 0 );
				SetTextColor( hdc, oldColor );
			}
			DrawEdge( hdc, &r, BDR_SUNKENOUTER, BF_RECT );
			SetTextColor( hdc, 0 );
			InflateRect( &r, -5, -5 );
			DrawText( hdc, commentBuffer, -1, &r, 0 );
			oldBrush = (HBRUSH)SelectObject( hdc, GetSysColorBrush( COLOR_3DFACE ) );
			PatBlt( hdc, cr.left, cr.top, cr.right-cr.left, cr.bottom-cr.top, PATCOPY );
			SelectObject( hdc, oldBrush );
			SelectObject( hdc, oldFont );
			EndPaint( hWnd, &ps );
			return 0;
		}
		case WM_DROPFILES:
		{
			HDROP hDrop;
			hDrop = (HDROP)wParam;
			DragQueryFile( hDrop, 0, &playFileName[0], sizeof(playFileName) );
			EnableNumOfSongScroll( FALSE );
			DragFinish( hDrop );

			loadNewSAP = 1;

			return 0;
		}
		case WM_COPYDATA:
		{
			PCOPYDATASTRUCT cds = (PCOPYDATASTRUCT)lParam;
			if( strlen( (char*)cds->lpData )>0 )
			{
				strcpy( &playFileName[0], (char*)cds->lpData );
				if( MakeCorrectFna( ) )
					loadNewSAP = 1;
			}
			break;
		}
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;
	}
	return DefWindowProc( hWnd, iMsg, wParam, lParam );
}

void ChangeSongNum( int pos )
{
	if( currentMusic != NULL )
	{
		if( pos != initSongNum )
		{
			initSongNum = pos;
			initNewSong = TRUE;
		}
	}
}

DWORD WINAPI DirectSoundThread( void )
{
int lengthBuf;
HANDLE thread;
double suma;
int sumaCnt;

	thread = GetCurrentThread();
	SetPriorityClass( thread, THREAD_PRIORITY_HIGHEST );

	bufferIsPlaying = FALSE;
	if( SoundThread()==TRUE )
		bufferIsPlaying = TRUE;

	isSomethingToPlay = 0;
	lastPos = 0;
	sndTh = 0;
	threadIsRunning = TRUE;

	suma = 0.0;
	sumaCnt = 0;

	while( sndTh==0 )
	{
		Sleep( SECONDARY_SOUND_BUFFER_IN_MS );
		if( DS_SecondaryBuffer==NULL )
			continue;
		if( (loadNewSAP==1) || (initNewSong==TRUE) )
		{
			if( currentMusic )
				currentMusic->currentTimeIn50Sec = 0;
			DS_SecondaryBuffer->Stop();
			bufferIsPlaying = FALSE;
			if( loadNewSAP==1 )
			{
				currentMusic = sapLoadMusicFile( playFileName );
				if( currentMusic!=NULL )
				{
					initSongNum = currentMusic->defSong;
					if( currentMusic->commentBuffer!=NULL )
						strcpy( commentBuffer, currentMusic->commentBuffer );
				}
			}
			if( currentMusic!=NULL )
			{
				if( initNewSong==TRUE )
				{
					sapPlaySong( initSongNum );
				}
				if( currentMusic->numOfSongs>1 )
				{
					EnableNumOfSongScroll( TRUE, currentMusic->numOfSongs, initSongNum );
				}
				else
				{
					EnableNumOfSongScroll( FALSE );
				}
				int lenBuf; lenBuf = PRIMARYBUFFERLENGTH;
				sapRenderBuffer( (short int*)&buf[0], lenBuf/4 );
				if( DS_SecondaryBuffer!=NULL )
				{
					if( DS_SecondaryBuffer->Lock( 0, lenBuf, &lpvPtr1, &dwBytes1, &lpvPtr2, &dwBytes2, 0)==DS_OK )
					{
						memcpy( lpvPtr1, &buf[0], dwBytes1 );
						if( dwBytes2!=0 )
							memcpy( lpvPtr2, &((BYTE*)&buf[0])[dwBytes1], dwBytes2 );
						DS_SecondaryBuffer->Unlock( lpvPtr1, dwBytes1, lpvPtr2, dwBytes2 );
					}
				}
				DS_SecondaryBuffer->SetCurrentPosition( 0 );
				DS_SecondaryBuffer->Play(0,0,DSBPLAY_LOOPING);
				lastPos = 0;
				isSomethingToPlay = 1;
				bufferIsPlaying = TRUE;
			}
			RedrawWindow( hWndMain, NULL, NULL, RDW_ERASE|RDW_INVALIDATE );
			if( loadNewSAP==1 )
				loadNewSAP = 0;
			if( initNewSong==TRUE )
				initNewSong = FALSE;
		}

		if( bufferIsPlaying==FALSE )
			continue;

		DS_SecondaryBuffer->GetCurrentPosition( &curPlayPos, &curWritePos );
		lengthBuf = curPlayPos-lastPos;
		if( lengthBuf==0 )
			continue;	
		if( lengthBuf<0 )
			lengthBuf+=PRIMARYBUFFERLENGTH;
		if( (isSomethingToPlay==0) || (currentMusic==NULL) )
		{
			memset( buf, 0, lengthBuf );
		}
		else
		{
			LARGE_INTEGER cnt1,cnt2,freq; double tempd;
			QueryPerformanceCounter( &cnt1 );
			sapRenderBuffer( (short int*)&buf[0], lengthBuf/4 );
			QueryPerformanceCounter( &cnt2 );
			QueryPerformanceFrequency( &freq );
			cnt2.QuadPart -= cnt1.QuadPart;
			tempd = (((double)cnt2.QuadPart) / ((double)freq.QuadPart));
			tempd *= 44100.0 / ((double)lengthBuf/4);
			tempd *= 100.0;
			suma += tempd;
			if( ++sumaCnt==4 )
			{
				int timeM,timeS;
				timeM = timeS = 0;
				if( currentMusic )
				{
					int timeInS = currentMusic->currentTimeIn50Sec / (312*50);
					timeM = timeInS / 60;
					timeS = timeInS % 60;
				}
				extern int currentPCPos,numsPerFrame;
				extern BYTE vvv[16];
				//sprintf( cmd1Line, "CPU % 3.2f%%.  Time %d:%02d. IRQfreq ~%dhz. %02X %02X %02X %02X %02X %02X %02X %02X %02X ", suma/4.0, timeM, timeS, numsPerFrame*50, vvv[0], vvv[1], vvv[2], vvv[3], vvv[4], vvv[5], vvv[6], vvv[7], vvv[8] );
				sprintf( cmd1Line, "CPU % 3.2f%%.  Time %d:%02d", suma/4.0, timeM, timeS );
				RedrawWindow( hWndMain, NULL, NULL, RDW_INVALIDATE|RDW_ERASE|RDW_UPDATENOW );
//				SendMessage( hWndMain, WM_SETTEXT, 0, (LPARAM)baba );
				sumaCnt = 0;
				suma = 0.0;
			}
		}
		if( DS_SecondaryBuffer->Lock( lastPos, lengthBuf, &lpvPtr1, &dwBytes1, &lpvPtr2, &dwBytes2, 0)==DS_OK )
		{
			memcpy( lpvPtr1, &buf[0], dwBytes1 );
			if( dwBytes2!=0 )
				memcpy( lpvPtr2, &((BYTE*)&buf[0])[dwBytes1], dwBytes2 );
			DS_SecondaryBuffer->Unlock( lpvPtr1, dwBytes1, lpvPtr2, dwBytes2 );
		}
		//FILE* of = fopen( "c:/a.bin", "ab" );
		//fwrite( buf, 1, lengthBuf, of );
		//fclose( of );
		lastPos = curPlayPos;
	}
	threadIsRunning = FALSE;
	ExitThread(0);
	return 0;
}


void PrintDSERR( char *t, HRESULT hr )
{
char bbb[100];

	switch( hr ) {
		case DSERR_ALLOCATED:
			MessageBox( hWndMain, "DSERR_ALLOCATED", t, 0 );
			break;
		case DSERR_BADFORMAT:
			MessageBox( hWndMain, "DSERR_BADFORMAT", t, 0 );
			break;
		case DSERR_INVALIDPARAM:
			MessageBox( hWndMain, "DSERR_INVALIDPARAM", t, 0 );
			break;
		case DSERR_BUFFERLOST:
			MessageBox( hWndMain, "DSERR_BUFFERLOST", t, 0 );
			break;
		case DSERR_UNSUPPORTED:
			MessageBox( hWndMain, "DSERR_UNSUPPORTED", t, 0 );
			break;
		case DSERR_UNINITIALIZED:
			MessageBox( hWndMain, "DSERR_UNINITIALIZED", t, 0 );
			break;
		case DSERR_INVALIDCALL:
			MessageBox( hWndMain, "DSERR_INVALIDCALL", t, 0 );
			break;
		case DSERR_PRIOLEVELNEEDED:
			MessageBox( hWndMain, "DSERR_PRIOLEVELNEEDED", t, 0 );
			break;
		default:
			wsprintf( &bbb[0], "DSERR_OTHER: %ld, 0x%lX\0", hr, hr );
			MessageBox( hWndMain,&bbb[0], t, 0 );
	}
}

DWORD WINAPI SoundThread( void )
{

	if( (hr=DirectSoundCreate( NULL, &lpDS_device, NULL ))!=DS_OK )
	{
		PrintDSERR( "Create lpGuid", hr );
		return FALSE;
	}
	if( (hr=lpDS_device->SetCooperativeLevel( hWndMain, DSSCL_EXCLUSIVE ))!=DS_OK )
	{
		lpDS_device->Release();
		PrintDSERR( "Cooperative Level", hr );
		return FALSE;
	}
	memset( &pcmwf, 0, sizeof(pcmwf) );
    pcmwf.wf.wFormatTag			= WAVE_FORMAT_PCM;
	pcmwf.wf.nChannels			= 2;
    pcmwf.wf.nSamplesPerSec		= 44100;
    pcmwf.wf.nBlockAlign		= 4;
	pcmwf.wf.nAvgBytesPerSec	= 44100 * 2 * 2; // pcmwf.wf.nSamplesPerSec * pcmwf.wf.nBlockAlign;
    pcmwf.wBitsPerSample		= 16;
	memset (&dsdescPrimaryBuffer, 0, sizeof (dsdescPrimaryBuffer));
    dsdescPrimaryBuffer.dwSize	= sizeof(DSBUFFERDESC);
	dsdescPrimaryBuffer.dwFlags	=  DSBCAPS_PRIMARYBUFFER;
	if( (hr=lpDS_device->CreateSoundBuffer( &dsdescPrimaryBuffer, &DS_PrimaryBuffer, NULL))!=DS_OK )
	{
		lpDS_device->Release();
		PrintDSERR( "Create Primary Buffer", hr );
		return FALSE;
	}
	if( (hr= DS_PrimaryBuffer->SetFormat( (WAVEFORMATEX*)&pcmwf ))!=DS_OK) {
		PrintDSERR( "Set Primary Format", hr );
		return FALSE;
	}
	if( (hr= DS_PrimaryBuffer->Play( 0, 0, DSBPLAY_LOOPING ))!=DS_OK ) {
		PrintDSERR( "Playing Primary", hr );
		return FALSE;
	}
	memset (&dsdescSecondaryBuffer, 0, sizeof (dsdescSecondaryBuffer));
    dsdescSecondaryBuffer.dwSize		= sizeof(DSBUFFERDESC);
	dsdescSecondaryBuffer.dwFlags		= DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY | DSBCAPS_STICKYFOCUS;
	dsdescSecondaryBuffer.dwBufferBytes	= PRIMARYBUFFERLENGTH;
	dsdescSecondaryBuffer.lpwfxFormat	= (WAVEFORMATEX*)&pcmwf;
	if( (hr=lpDS_device->CreateSoundBuffer( &dsdescSecondaryBuffer, &DS_SecondaryBuffer, NULL))!=DS_OK ) {
		PrintDSERR( "Create Secondary Buffer", hr );
		return FALSE;
	}
//	if( (hr=DS_SecondaryBuffer->Play( 0, 0, DSBPLAY_LOOPING))!=DS_OK )
//	{
//		PrintDSERR( "Playing Secondary Buffer", hr );
//		return FALSE;
//	}
	lastPos = 0;
	return TRUE;
}


