
#ifdef _MSC_EXTENSIONS
#pragma pack(push)
#pragma pack(1)
#endif
typedef struct {
	int		numOfSongs;
	int		defSong; // zero based index (0....numOfSongs-1)
	char	*commentBuffer;
	int		currentTimeIn50Sec;
} sapMUSICstrc;
#ifdef _MSC_EXTENSIONS
#pragma pack(pop)
#endif

typedef enum PCMWave
{
	PCMWAVE_Atari,
	PCMWAVE_FM1,
	PCMWAVE_FM2,
	PCMWAVE_FM3,
	PCMWAVE_Saw,
};


sapMUSICstrc* __fastcall sapLoadMusicFile( char *fname );
void __fastcall sapPlaySong( int numOfSong );
void __fastcall sapRenderBuffer( signed short *buffer, int number_of_samples );
void __fastcall sapSetPCMWave( PCMWave new_wave );
void __fastcall sapSetChannelMute( bool mute_channel0, bool mute_channel1, bool mute_channel2, bool mute_channel3 );

// don't delete sapMUSICstrc returned via sapLoadMusicFile!!!
// don't modify or delete commentBuffer pointed by this structure!!!
// if error occurs, then sapLoadMusicFile returns NULL.
// sapRenderBuffer, fills given buffer with [number_of_samples] stereo 16bit signed samples.
// example:
//
// sapMUSICstrc *currentFile;
// unsigned char playBuffer[44100];
// int currentSong;
//
// currentFile = sapLoadMusicFile( "music.sap" );
// currentSong = currentFile->defSong;
// again:
// while(key)
// {
//	sapRenderBuffer( &playBuffer, 44100 / 4 );
//	__play_buffer( );
// }
// if( key==next_song )
// {
//     currentSong = (currentSong+1) % currentFile->numOfSongs;
//     sapPlaySong( current_song );
//     goto again;
// }
// No data need to be deleted, because SAP is using only static data
// and is able to play only one song at time

