#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "../sapLib/sapLib.h"
#include "in2.h"

extern void __cdecl OpenControlWindow( HWND parent );
extern void __cdecl EnableNumOfSongScroll( BOOL enable, int max = 0, int current = 0 );
int TimeLimitTime = 3;
int initSongNum = 0;
BOOL initNewSong = FALSE;
sapMUSICstrc *currentMusic = NULL;
static __int64 currentPlayTimeInBytes;

#define WM_WA_MPEG_EOF WM_USER+2

extern In_Module mod;

short sample_buffer[576*2];
char playFileName[260];

int paused;
DWORD WINAPI __stdcall PlayThread(void *b);

int killDecodeThread=0;
HANDLE thread_handle=INVALID_HANDLE_VALUE;


ATOM atomIs = 0;
char szMainWindowClassName[]="szSAPMainWindowClassName";
HHOOK prevHookRet;
HRGN wndRgn;
HWND sapWindow=NULL;

LRESULT CALLBACK hookProcRet( int nCode, WPARAM wParam, LPARAM lParam )
{
CWPRETSTRUCT *cs;

	cs = (CWPRETSTRUCT*)lParam;

	if( cs->hwnd==mod.hMainWindow )
	{
		if( cs->message==WM_MOVE )
		{
			if( sapWindow )
			{
//				RECT wr;
//				GetWindowRect( mod.hMainWindow, &wr );
//				MoveWindow( sapWindow, wr.left, wr.bottom, 275, 100, TRUE );
			}
		}
	}
	return CallNextHookEx( prevHookRet, nCode, wParam, lParam );
}

long CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
		case WM_CREATE:
			return 0;
		case WM_ERASEBKGND:
			return 1;
		case WM_PAINT:
		{
			RECT cr; GetClientRect( hWnd, &cr );
			PAINTSTRUCT ps; HDC hdc;
			hdc = BeginPaint( hWnd, &ps );
			PatBlt( hdc, 0, 0, cr.right-cr.left, cr.bottom-cr.top, WHITENESS );
			EndPaint( hWnd, &ps );
			return 0;
		}
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

void config(HWND hwndParent)
{
	OpenControlWindow( hwndParent );
//	MessageBox(hwndParent,"No config. Just use it ;)","Configuration",MB_OK);
}
void about(HWND hwndParent)
{
	MessageBox(hwndParent,"Slight Atari Player SAP, by Adam Bienias","About SAP",MB_OK);
}

void init()
{
	prevHookRet = SetWindowsHookEx( WH_CALLWNDPROCRET, &hookProcRet, mod.hDllInstance, 0 );
}

void quit()
{
	UnhookWindowsHookEx( prevHookRet );
}

int isourfile(char *fn) 
{ 
	return 0;

	char buf[8];
	memcpy(buf,fn,7);
	buf[7]=0;
	return lstrcmp(buf,"tone://")?0:1; 
}

int play(char *fn)
{
	int maxlatency;
	int tmp;

	paused=0;
	memset(sample_buffer,0,sizeof(sample_buffer));

	maxlatency = mod.outMod->Open(44100,2,16, -1,-1);
	if (maxlatency < 0)
	{
		return 1;
	}
	mod.SetInfo(0,44,2,1);
	mod.SAVSAInit(maxlatency,44100);
	mod.VSASetInfo(44100,2);
	mod.outMod->SetVolume(-666);		

	currentMusic = NULL;
	initSongNum = 0;
	{
		strcpy( playFileName, fn );
		sapSetPCMWave( PCMWAVE_Atari );
		sapSetChannelMute( false, false, false, false );
		EnableNumOfSongScroll( FALSE );
		currentMusic = sapLoadMusicFile( fn );
		if( currentMusic!=NULL )
		{
			initSongNum = currentMusic->defSong;
			currentPlayTimeInBytes = 0;
		}
	}
	killDecodeThread=0;
	thread_handle = (HANDLE) CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) PlayThread,(void *) &killDecodeThread,0,(DWORD*)&tmp);
	
	return 0; 
}

void pause() { paused=1; mod.outMod->Pause(1); }
void unpause() { paused=0; mod.outMod->Pause(0); }
int ispaused() { return paused; }

void stop()
{
	if( sapWindow )
		DestroyWindow( sapWindow );
	sapWindow = NULL;

	if (thread_handle != INVALID_HANDLE_VALUE)
	{
		killDecodeThread=1;
		if (WaitForSingleObject(thread_handle,INFINITE) == WAIT_TIMEOUT)
		{
			MessageBox(mod.hMainWindow,"error asking thread to die!\n","error killing decode thread",0);
			TerminateThread(thread_handle,0);
		}
		CloseHandle(thread_handle);
		thread_handle = INVALID_HANDLE_VALUE;
	}

	mod.outMod->Close();
	mod.SAVSADeInit();
}

int getlength() { return TimeLimitTime * 60 * 1000; }
int getoutputtime() { return mod.outMod->GetOutputTime(); }
void setoutputtime(int time_in_ms) {  }

void setvolume(int volume) { mod.outMod->SetVolume(volume); }
void setpan(int pan) { mod.outMod->SetPan(pan); }

int infoDlg(char *fn, HWND hwnd)
{
	return 0;
}

void getfileinfo(char *filename, char *title, int *length_in_ms)
{
	if (!filename || !*filename)
		filename=playFileName;
	if (title) 
	{
		char fname[MAX_PATH];
		_splitpath( filename, NULL, NULL, fname, NULL );
		wsprintf( title,"%s - AtariXL/XE", fname );
	}
	if (length_in_ms) *length_in_ms = TimeLimitTime * 60 * 1000;
}

void eq_set(int on, char data[10], int preamp) 
{ 
}


In_Module mod = 
{
	IN_VER,
	"Slight Atari Player v2.0 "
#ifdef __alpha
	"(AXP)"
#else
	"(x86)"
#endif
	,
	0,	// hMainWindow
	0,  // hDllInstance
	"SAP\0SAP Atari File (*.SAP)\0"
	,
	1,	// is_seekable
	1, // uses output
	config,
	about,
	init,
	quit,
	getfileinfo,
	infoDlg,
	isourfile,
	play,
	pause,
	unpause,
	ispaused,
	stop,
	
	getlength,
	getoutputtime,
	setoutputtime,

	setvolume,
	setpan,

	0,0,0,0,0,0,0,0,0, // vis stuff


	0,0, // dsp

	eq_set,

	NULL,		// setinfo

	0 // out_mod

};

extern "C" __declspec( dllexport ) In_Module* winampGetInModule2();


__declspec( dllexport ) In_Module* winampGetInModule2()
{
	return &mod;
}

int _fltused=0;

void ChangeSongNum( int pos )
{
	if( currentMusic != NULL )
	{
		if( pos != initSongNum )
		{
			initSongNum = pos;
			initNewSong = TRUE;
		}
	}
}

DWORD WINAPI __stdcall PlayThread(void *b)
{
	while (! *((int *)b) ) 
	{
		if (mod.outMod->CanWrite() >= (int)((sizeof(sample_buffer)/2)<<(mod.dsp_isactive()?1:0)))
		{	
			int l = sizeof(sample_buffer);
			if( currentMusic != NULL )
			{
				if( initNewSong==TRUE )
				{
					sapPlaySong( initSongNum );
					currentPlayTimeInBytes = 0;
				}
				if( currentMusic->numOfSongs > 1 )
				{
					EnableNumOfSongScroll( TRUE, currentMusic->numOfSongs, initSongNum );
				}
				else
				{
					EnableNumOfSongScroll( FALSE );
				}
				initNewSong = FALSE;
			}

			sapRenderBuffer( sample_buffer, sizeof(sample_buffer) / 4 );
			{
				int t = mod.outMod->GetWrittenTime();
				mod.SAAddPCMData((char *)sample_buffer,2,16,t);
				mod.VSAAddPCMData((char *)sample_buffer,2,16,t);
			}

			if (mod.dsp_isactive()) l=mod.dsp_dosamples(sample_buffer,sizeof(sample_buffer)/4,16,2,44100)*4;
			mod.outMod->Write((char*)&sample_buffer[0],l);

			currentPlayTimeInBytes += sizeof(sample_buffer);

			if( (currentPlayTimeInBytes / (44100*4)) > (TimeLimitTime*60) )
			{
				if( !mod.outMod->IsPlaying() )
				{
					PostMessage( mod.hMainWindow,WM_WA_MPEG_EOF,0,0 );
					return 0;
				}
				Sleep( 20 );
			}
		}
		else
		{
			Sleep(50);
		}
	}
	return 0;
}

